#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27,16,2);   // Задаем адрес и размерность дисплея. 

volatile float time = 0;
volatile float time_last = 0;
volatile long rt_blades = 0;
volatile static unsigned long lastPressed=0;
volatile boolean ledOn = false;
volatile int rpm_array[5] = {0,0,0,0,0};
volatile int blades = 7;
float time_step = 0;
int next = 0;
long rotations = 0;
int rpm = 0;
float time_current = 0;
boolean gogogo = false;
//=====================================
void setup() {
  Serial.begin(9600); 
  Serial.println("TACHOMETER2");
  pinMode(13, OUTPUT);
  lcd.init();                
  lcd.backlight();           
  lcd.print(" TACHOMETER2"); 
  delay(1000);
  lcd.setCursor(0, 0);
  lcd.print("BLD:             ");
  lcd.setCursor(5, 0);
  lcd.print(blades);
  lcd.setCursor(0, 1);    
  lcd.print("RPM: ");      
  attachInterrupt(0, fan_interrupt, FALLING);
  attachInterrupt(1, swap, RISING);
}
//=====================================
void fan_interrupt()
{
  time_current = micros();
  time = (time_current - time_last); 
  time_last = time_current;
  rt_blades++;
}
//=====================================
void swap(){
  if(millis()-lastPressed<300)return;// если с прошлого нажатия прошло меньше 100ms - игнорируем этот импульс
  lastPressed=millis();// запомнили когда было последние нажатие
  ledOn=!ledOn;
  digitalWrite(13,ledOn);
  Serial.print("INT1");
  blades++;
  if (blades>10) blades=1;
}
//=====================================
void loop() {
  if (micros()-time_step > 400000) {
    gogogo = true;
    time_step = micros();
  }  
  
  if ((time > 0)&(gogogo)) {
    rpm_array[next] = 60*(1000000/(time*blades));
    next++;
    if (next > 4) next=0;
    rpm = 0;
    for (int i=0; i<=4; i++) rpm=rpm+rpm_array[i];
    rpm = rpm / 5;

/*    for (int i=0; i<=4; i++) {
      Serial.print(rpm_array[i]);
      Serial.print(" ");
    }  
    Serial.println(); */
    
    lcd_print();
    gogogo=false;
    time = 0;      
  } else if ((time < 1)&(gogogo)) {  /// нет вращения - забиваем нулями
    rpm_array[next] = 0;
    next++;
    if (next > 4) next=0;
    rpm = 0;
    for (int i=0; i<=4; i++) rpm=rpm+rpm_array[i];
    rpm = rpm / 5;
/*    for (int i=0; i<=4; i++) {
      Serial.print(rpm_array[i]);
      Serial.print(" ");
    }  
    Serial.println(); */
    lcd_print();
    gogogo=false;
  }  
 
}
//=====================================
void lcd_print(){
  lcd.setCursor(5, 0);
  lcd.print("   ");
  lcd.setCursor(5, 0);
  lcd.print(blades);
  lcd.setCursor(11, 0);
  rotations = rt_blades/blades;
  lcd.print(rotations);
  lcd.setCursor(0, 1);
  lcd.print("RPM:          ");
  lcd.setCursor(5, 1);
  lcd.print(rpm);
}
